/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy_grecs or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yy_grecstokentype {
     IDENT = 258,
     STRING = 259,
     QSTRING = 260,
     MSTRING = 261
   };
#endif
/* Tokens.  */
#define IDENT 258
#define STRING 259
#define QSTRING 260
#define MSTRING 261




/* Copy the first part of user declarations.  */
#line 1 "grecs-gram.y"

/* grecs - Gray's Extensible Configuration System
   Copyright (C) 2007, 2008, 2009 Sergey Poznyakoff

   Grecs is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3 of the License, or (at your
   option) any later version.

   Grecs is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with Grecs. If not, see <http://www.gnu.org/licenses/>. */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <grecs.h>
#include <grecs-gram.h>
#include <stdlib.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/un.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <string.h>

#include <xalloc.h>
#include <inttypes.h>

#if ENABLE_NLS
# include "gettext.h"
# define _(msgid) gettext (msgid)
#else
# define _(msgid) msgid
#endif
  
typedef union
{
  struct sockaddr s;
  struct sockaddr_in s_in;
  struct sockaddr_un s_un;
} sockaddr_union_t;

static struct grecs_keyword config_keywords;
static struct grecs_keyword *cursect;
#define CURRENT_BASE ((char*)(cursect ? cursect->callback_data : NULL))
static gl_list_t sections;
int grecs_error_count;    

int grecs_default_port = 0;

static void *target_ptr (struct grecs_keyword *kwp, char *base);
static void stmt_begin (struct grecs_keyword *kwp, grecs_value_t tag);
static void stmt_end (struct grecs_keyword *kwp);
static struct grecs_keyword *find_keyword (const char *ident);

static void process_ident (struct grecs_keyword *kwp, grecs_value_t *value);
static gl_list_t simple_list_create (bool dispose);


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 68 "grecs-gram.y"
{
  char *string;
  grecs_value_t value;
  gl_list_t list;
  struct grecs_keyword *kw;
}
/* Line 187 of yacc.c.  */
#line 182 "grecs-gram.c"
	YYSTYPE;
# define yy_grecsstype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 195 "grecs-gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yy_grecstype_uint8;
#else
typedef unsigned char yy_grecstype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yy_grecstype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yy_grecstype_int8;
#else
typedef short int yy_grecstype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yy_grecstype_uint16;
#else
typedef unsigned short int yy_grecstype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yy_grecstype_int16;
#else
typedef short int yy_grecstype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yy_grecsoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yy_grecsoverflow || YYERROR_VERBOSE */


#if (! defined yy_grecsoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yy_grecsalloc
{
  yy_grecstype_int16 yy_grecsss;
  YYSTYPE yy_grecsvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yy_grecsalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yy_grecstype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yy_grecsi;				\
	  for (yy_grecsi = 0; yy_grecsi < (Count); yy_grecsi++)	\
	    (To)[yy_grecsi] = (From)[yy_grecsi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yy_grecsnewbytes;						\
	YYCOPY (&yy_grecsptr->Stack, Stack, yy_grecssize);				\
	Stack = &yy_grecsptr->Stack;						\
	yy_grecsnewbytes = yy_grecsstacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yy_grecsptr += yy_grecsnewbytes / sizeof (*yy_grecsptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  8
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   33

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  13
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  18
/* YYNRULES -- Number of rules.  */
#define YYNRULES  31
/* YYNRULES -- Number of states.  */
#define YYNSTATES  39

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   261

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yy_grecstranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yy_grecstype_uint8 yy_grecstranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      10,    11,     2,     2,    12,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     7,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     8,     2,     9,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yy_grecstype_uint8 yy_grecsprhs[] =
{
       0,     0,     3,     5,     7,    10,    12,    14,    18,    19,
      27,    29,    30,    32,    34,    36,    39,    41,    43,    45,
      47,    49,    51,    53,    55,    58,    61,    65,    70,    72,
      76,    77
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yy_grecstype_int8 yy_grecsrhs[] =
{
      14,     0,    -1,    15,    -1,    16,    -1,    15,    16,    -1,
      17,    -1,    18,    -1,    20,    22,     7,    -1,    -1,    20,
      21,    19,     8,    15,     9,    30,    -1,     3,    -1,    -1,
      24,    -1,    23,    -1,    24,    -1,    23,    24,    -1,    25,
      -1,    28,    -1,     6,    -1,     4,    -1,     3,    -1,    26,
      -1,    27,    -1,     5,    -1,    27,     5,    -1,    10,    11,
      -1,    10,    29,    11,    -1,    10,    29,    12,    11,    -1,
      24,    -1,    29,    12,    24,    -1,    -1,     7,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yy_grecstype_uint8 yy_grecsrline[] =
{
       0,    84,    84,    87,    88,    91,    92,    95,   101,   101,
     107,   116,   120,   123,   145,   150,   156,   161,   166,   173,
     174,   175,   178,   192,   197,   204,   208,   212,   218,   223,
     230,   231
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yy_grecstname[] =
{
  "$end", "error", "$undefined", "IDENT", "STRING", "QSTRING", "MSTRING",
  "';'", "'{'", "'}'", "'('", "')'", "','", "$accept", "input", "stmtlist",
  "stmt", "simple", "block", "@1", "ident", "tag", "vallist", "vlist",
  "value", "string", "slist", "slist0", "list", "values", "opt_sc", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yy_grecstype_uint16 yy_grecstoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,    59,   123,   125,
      40,    41,    44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yy_grecstype_uint8 yy_grecsr1[] =
{
       0,    13,    14,    15,    15,    16,    16,    17,    19,    18,
      20,    21,    21,    22,    23,    23,    24,    24,    24,    25,
      25,    25,    26,    27,    27,    28,    28,    28,    29,    29,
      30,    30
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yy_grecstype_uint8 yy_grecsr2[] =
{
       0,     2,     1,     1,     2,     1,     1,     3,     0,     7,
       1,     0,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     3,     4,     1,     3,
       0,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yy_grecstype_uint8 yy_grecsdefact[] =
{
       0,    10,     0,     2,     3,     5,     6,    11,     1,     4,
      20,    19,    23,    18,     0,     8,     0,    13,    14,    16,
      21,    22,    17,    25,    28,     0,     0,     7,    15,    24,
      26,     0,     0,    27,    29,     0,    30,    31,     9
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yy_grecstype_int8 yy_grecsdefgoto[] =
{
      -1,     2,     3,     4,     5,     6,    26,     7,    15,    16,
      17,    18,    19,    20,    21,    22,    25,    38
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -14
static const yy_grecstype_int8 yy_grecspact[] =
{
      16,   -14,    27,    16,   -14,   -14,   -14,    20,   -14,   -14,
     -14,   -14,   -14,   -14,     2,   -14,    -5,    20,    12,   -14,
     -14,    23,   -14,   -14,   -14,    -1,    21,   -14,   -14,   -14,
     -14,    11,    16,   -14,   -14,     0,    24,   -14,   -14
};

/* YYPGOTO[NTERM-NUM].  */
static const yy_grecstype_int8 yy_grecspgoto[] =
{
     -14,   -14,     1,    -3,   -14,   -14,   -14,   -14,   -14,   -14,
     -14,   -13,   -14,   -14,   -14,   -14,   -14,   -14
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -13
static const yy_grecstype_int8 yy_grecstable[] =
{
       9,    24,    27,     1,    28,    10,    11,    12,    13,    36,
      30,    31,    14,    23,    10,    11,    12,    13,    34,     1,
     -12,    14,    33,    10,    11,    12,    13,     8,    29,    32,
      14,    37,     9,    35
};

static const yy_grecstype_uint8 yy_grecscheck[] =
{
       3,    14,     7,     3,    17,     3,     4,     5,     6,     9,
      11,    12,    10,    11,     3,     4,     5,     6,    31,     3,
       8,    10,    11,     3,     4,     5,     6,     0,     5,     8,
      10,     7,    35,    32
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yy_grecstype_uint8 yy_grecsstos[] =
{
       0,     3,    14,    15,    16,    17,    18,    20,     0,    16,
       3,     4,     5,     6,    10,    21,    22,    23,    24,    25,
      26,    27,    28,    11,    24,    29,    19,     7,    24,     5,
      11,    12,     8,    11,    24,    15,     9,     7,    30
};

#define yy_grecserrok		(yy_grecserrstatus = 0)
#define yy_grecsclearin	(yy_grecschar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yy_grecsacceptlab
#define YYABORT		goto yy_grecsabortlab
#define YYERROR		goto yy_grecserrorlab


/* Like YYERROR except do call yy_grecserror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yy_grecserrlab

#define YYRECOVERING()  (!!yy_grecserrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yy_grecschar == YYEMPTY && yy_grecslen == 1)				\
    {								\
      yy_grecschar = (Token);						\
      yy_grecslval = (Value);						\
      yy_grecstoken = YYTRANSLATE (yy_grecschar);				\
      YYPOPSTACK (1);						\
      goto yy_grecsbackup;						\
    }								\
  else								\
    {								\
      yy_grecserror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yy_grecslex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yy_grecslex (YYLEX_PARAM)
#else
# define YYLEX yy_grecslex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yy_grecsdebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yy_grecsdebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_grecs_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_grecs_symbol_value_print (FILE *yy_grecsoutput, int yy_grecstype, YYSTYPE const * const yy_grecsvaluep)
#else
static void
yy_grecs_symbol_value_print (yy_grecsoutput, yy_grecstype, yy_grecsvaluep)
    FILE *yy_grecsoutput;
    int yy_grecstype;
    YYSTYPE const * const yy_grecsvaluep;
#endif
{
  if (!yy_grecsvaluep)
    return;
# ifdef YYPRINT
  if (yy_grecstype < YYNTOKENS)
    YYPRINT (yy_grecsoutput, yy_grecstoknum[yy_grecstype], *yy_grecsvaluep);
# else
  YYUSE (yy_grecsoutput);
# endif
  switch (yy_grecstype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_grecs_symbol_print (FILE *yy_grecsoutput, int yy_grecstype, YYSTYPE const * const yy_grecsvaluep)
#else
static void
yy_grecs_symbol_print (yy_grecsoutput, yy_grecstype, yy_grecsvaluep)
    FILE *yy_grecsoutput;
    int yy_grecstype;
    YYSTYPE const * const yy_grecsvaluep;
#endif
{
  if (yy_grecstype < YYNTOKENS)
    YYFPRINTF (yy_grecsoutput, "token %s (", yy_grecstname[yy_grecstype]);
  else
    YYFPRINTF (yy_grecsoutput, "nterm %s (", yy_grecstname[yy_grecstype]);

  yy_grecs_symbol_value_print (yy_grecsoutput, yy_grecstype, yy_grecsvaluep);
  YYFPRINTF (yy_grecsoutput, ")");
}

/*------------------------------------------------------------------.
| yy_grecs_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_grecs_stack_print (yy_grecstype_int16 *bottom, yy_grecstype_int16 *top)
#else
static void
yy_grecs_stack_print (bottom, top)
    yy_grecstype_int16 *bottom;
    yy_grecstype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yy_grecsdebug)							\
    yy_grecs_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_grecs_reduce_print (YYSTYPE *yy_grecsvsp, int yy_grecsrule)
#else
static void
yy_grecs_reduce_print (yy_grecsvsp, yy_grecsrule)
    YYSTYPE *yy_grecsvsp;
    int yy_grecsrule;
#endif
{
  int yy_grecsnrhs = yy_grecsr2[yy_grecsrule];
  int yy_grecsi;
  unsigned long int yy_grecslno = yy_grecsrline[yy_grecsrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yy_grecsrule - 1, yy_grecslno);
  /* The symbols being reduced.  */
  for (yy_grecsi = 0; yy_grecsi < yy_grecsnrhs; yy_grecsi++)
    {
      fprintf (stderr, "   $%d = ", yy_grecsi + 1);
      yy_grecs_symbol_print (stderr, yy_grecsrhs[yy_grecsprhs[yy_grecsrule] + yy_grecsi],
		       &(yy_grecsvsp[(yy_grecsi + 1) - (yy_grecsnrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yy_grecsdebug)				\
    yy_grecs_reduce_print (yy_grecsvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yy_grecsdebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yy_grecsstrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yy_grecsstrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yy_grecsstrlen (const char *yy_grecsstr)
#else
static YYSIZE_T
yy_grecsstrlen (yy_grecsstr)
    const char *yy_grecsstr;
#endif
{
  YYSIZE_T yy_grecslen;
  for (yy_grecslen = 0; yy_grecsstr[yy_grecslen]; yy_grecslen++)
    continue;
  return yy_grecslen;
}
#  endif
# endif

# ifndef yy_grecsstpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yy_grecsstpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yy_grecsstpcpy (char *yy_grecsdest, const char *yy_grecssrc)
#else
static char *
yy_grecsstpcpy (yy_grecsdest, yy_grecssrc)
    char *yy_grecsdest;
    const char *yy_grecssrc;
#endif
{
  char *yy_grecsd = yy_grecsdest;
  const char *yy_grecss = yy_grecssrc;

  while ((*yy_grecsd++ = *yy_grecss++) != '\0')
    continue;

  return yy_grecsd - 1;
}
#  endif
# endif

# ifndef yy_grecstnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yy_grecserror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yy_grecstname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yy_grecstnamerr (char *yy_grecsres, const char *yy_grecsstr)
{
  if (*yy_grecsstr == '"')
    {
      YYSIZE_T yy_grecsn = 0;
      char const *yy_grecsp = yy_grecsstr;

      for (;;)
	switch (*++yy_grecsp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yy_grecsp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yy_grecsres)
	      yy_grecsres[yy_grecsn] = *yy_grecsp;
	    yy_grecsn++;
	    break;

	  case '"':
	    if (yy_grecsres)
	      yy_grecsres[yy_grecsn] = '\0';
	    return yy_grecsn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yy_grecsres)
    return yy_grecsstrlen (yy_grecsstr);

  return yy_grecsstpcpy (yy_grecsres, yy_grecsstr) - yy_grecsres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yy_grecssyntax_error (char *yy_grecsresult, int yy_grecsstate, int yy_grecschar)
{
  int yy_grecsn = yy_grecspact[yy_grecsstate];

  if (! (YYPACT_NINF < yy_grecsn && yy_grecsn <= YYLAST))
    return 0;
  else
    {
      int yy_grecstype = YYTRANSLATE (yy_grecschar);
      YYSIZE_T yy_grecssize0 = yy_grecstnamerr (0, yy_grecstname[yy_grecstype]);
      YYSIZE_T yy_grecssize = yy_grecssize0;
      YYSIZE_T yy_grecssize1;
      int yy_grecssize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yy_grecsarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yy_grecsx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yy_grecsfmt;
      char const *yy_grecsf;
      static char const yy_grecsunexpected[] = "syntax error, unexpected %s";
      static char const yy_grecsexpecting[] = ", expecting %s";
      static char const yy_grecsor[] = " or %s";
      char yy_grecsformat[sizeof yy_grecsunexpected
		    + sizeof yy_grecsexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yy_grecsor - 1))];
      char const *yy_grecsprefix = yy_grecsexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yy_grecsxbegin = yy_grecsn < 0 ? -yy_grecsn : 0;

      /* Stay within bounds of both yy_grecscheck and yy_grecstname.  */
      int yy_grecschecklim = YYLAST - yy_grecsn + 1;
      int yy_grecsxend = yy_grecschecklim < YYNTOKENS ? yy_grecschecklim : YYNTOKENS;
      int yy_grecscount = 1;

      yy_grecsarg[0] = yy_grecstname[yy_grecstype];
      yy_grecsfmt = yy_grecsstpcpy (yy_grecsformat, yy_grecsunexpected);

      for (yy_grecsx = yy_grecsxbegin; yy_grecsx < yy_grecsxend; ++yy_grecsx)
	if (yy_grecscheck[yy_grecsx + yy_grecsn] == yy_grecsx && yy_grecsx != YYTERROR)
	  {
	    if (yy_grecscount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yy_grecscount = 1;
		yy_grecssize = yy_grecssize0;
		yy_grecsformat[sizeof yy_grecsunexpected - 1] = '\0';
		break;
	      }
	    yy_grecsarg[yy_grecscount++] = yy_grecstname[yy_grecsx];
	    yy_grecssize1 = yy_grecssize + yy_grecstnamerr (0, yy_grecstname[yy_grecsx]);
	    yy_grecssize_overflow |= (yy_grecssize1 < yy_grecssize);
	    yy_grecssize = yy_grecssize1;
	    yy_grecsfmt = yy_grecsstpcpy (yy_grecsfmt, yy_grecsprefix);
	    yy_grecsprefix = yy_grecsor;
	  }

      yy_grecsf = YY_(yy_grecsformat);
      yy_grecssize1 = yy_grecssize + yy_grecsstrlen (yy_grecsf);
      yy_grecssize_overflow |= (yy_grecssize1 < yy_grecssize);
      yy_grecssize = yy_grecssize1;

      if (yy_grecssize_overflow)
	return YYSIZE_MAXIMUM;

      if (yy_grecsresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yy_grecsp = yy_grecsresult;
	  int yy_grecsi = 0;
	  while ((*yy_grecsp = *yy_grecsf) != '\0')
	    {
	      if (*yy_grecsp == '%' && yy_grecsf[1] == 's' && yy_grecsi < yy_grecscount)
		{
		  yy_grecsp += yy_grecstnamerr (yy_grecsp, yy_grecsarg[yy_grecsi++]);
		  yy_grecsf += 2;
		}
	      else
		{
		  yy_grecsp++;
		  yy_grecsf++;
		}
	    }
	}
      return yy_grecssize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_grecsdestruct (const char *yy_grecsmsg, int yy_grecstype, YYSTYPE *yy_grecsvaluep)
#else
static void
yy_grecsdestruct (yy_grecsmsg, yy_grecstype, yy_grecsvaluep)
    const char *yy_grecsmsg;
    int yy_grecstype;
    YYSTYPE *yy_grecsvaluep;
#endif
{
  YYUSE (yy_grecsvaluep);

  if (!yy_grecsmsg)
    yy_grecsmsg = "Deleting";
  YY_SYMBOL_PRINT (yy_grecsmsg, yy_grecstype, yy_grecsvaluep, yy_grecslocationp);

  switch (yy_grecstype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yy_grecsparse (void *YYPARSE_PARAM);
#else
int yy_grecsparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yy_grecsparse (void);
#else
int yy_grecsparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yy_grecschar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yy_grecslval;

/* Number of syntax errors so far.  */
int yy_grecsnerrs;



/*----------.
| yy_grecsparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yy_grecsparse (void *YYPARSE_PARAM)
#else
int
yy_grecsparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yy_grecsparse (void)
#else
int
yy_grecsparse ()

#endif
#endif
{
  
  int yy_grecsstate;
  int yy_grecsn;
  int yy_grecsresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yy_grecserrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yy_grecstoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yy_grecsmsgbuf[128];
  char *yy_grecsmsg = yy_grecsmsgbuf;
  YYSIZE_T yy_grecsmsg_alloc = sizeof yy_grecsmsgbuf;
#endif

  /* Three stacks and their tools:
     `yy_grecsss': related to states,
     `yy_grecsvs': related to semantic values,
     `yy_grecsls': related to locations.

     Refer to the stacks thru separate pointers, to allow yy_grecsoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yy_grecstype_int16 yy_grecsssa[YYINITDEPTH];
  yy_grecstype_int16 *yy_grecsss = yy_grecsssa;
  yy_grecstype_int16 *yy_grecsssp;

  /* The semantic value stack.  */
  YYSTYPE yy_grecsvsa[YYINITDEPTH];
  YYSTYPE *yy_grecsvs = yy_grecsvsa;
  YYSTYPE *yy_grecsvsp;



#define YYPOPSTACK(N)   (yy_grecsvsp -= (N), yy_grecsssp -= (N))

  YYSIZE_T yy_grecsstacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yy_grecsval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yy_grecslen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yy_grecsstate = 0;
  yy_grecserrstatus = 0;
  yy_grecsnerrs = 0;
  yy_grecschar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yy_grecsssp = yy_grecsss;
  yy_grecsvsp = yy_grecsvs;

  goto yy_grecssetstate;

/*------------------------------------------------------------.
| yy_grecsnewstate -- Push a new state, which is found in yy_grecsstate.  |
`------------------------------------------------------------*/
 yy_grecsnewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yy_grecsssp++;

 yy_grecssetstate:
  *yy_grecsssp = yy_grecsstate;

  if (yy_grecsss + yy_grecsstacksize - 1 <= yy_grecsssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yy_grecssize = yy_grecsssp - yy_grecsss + 1;

#ifdef yy_grecsoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yy_grecsvs1 = yy_grecsvs;
	yy_grecstype_int16 *yy_grecsss1 = yy_grecsss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yy_grecsoverflow is a macro.  */
	yy_grecsoverflow (YY_("memory exhausted"),
		    &yy_grecsss1, yy_grecssize * sizeof (*yy_grecsssp),
		    &yy_grecsvs1, yy_grecssize * sizeof (*yy_grecsvsp),

		    &yy_grecsstacksize);

	yy_grecsss = yy_grecsss1;
	yy_grecsvs = yy_grecsvs1;
      }
#else /* no yy_grecsoverflow */
# ifndef YYSTACK_RELOCATE
      goto yy_grecsexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yy_grecsstacksize)
	goto yy_grecsexhaustedlab;
      yy_grecsstacksize *= 2;
      if (YYMAXDEPTH < yy_grecsstacksize)
	yy_grecsstacksize = YYMAXDEPTH;

      {
	yy_grecstype_int16 *yy_grecsss1 = yy_grecsss;
	union yy_grecsalloc *yy_grecsptr =
	  (union yy_grecsalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yy_grecsstacksize));
	if (! yy_grecsptr)
	  goto yy_grecsexhaustedlab;
	YYSTACK_RELOCATE (yy_grecsss);
	YYSTACK_RELOCATE (yy_grecsvs);

#  undef YYSTACK_RELOCATE
	if (yy_grecsss1 != yy_grecsssa)
	  YYSTACK_FREE (yy_grecsss1);
      }
# endif
#endif /* no yy_grecsoverflow */

      yy_grecsssp = yy_grecsss + yy_grecssize - 1;
      yy_grecsvsp = yy_grecsvs + yy_grecssize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yy_grecsstacksize));

      if (yy_grecsss + yy_grecsstacksize - 1 <= yy_grecsssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yy_grecsstate));

  goto yy_grecsbackup;

/*-----------.
| yy_grecsbackup.  |
`-----------*/
yy_grecsbackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yy_grecsn = yy_grecspact[yy_grecsstate];
  if (yy_grecsn == YYPACT_NINF)
    goto yy_grecsdefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yy_grecschar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yy_grecschar = YYLEX;
    }

  if (yy_grecschar <= YYEOF)
    {
      yy_grecschar = yy_grecstoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yy_grecstoken = YYTRANSLATE (yy_grecschar);
      YY_SYMBOL_PRINT ("Next token is", yy_grecstoken, &yy_grecslval, &yy_grecslloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yy_grecsn += yy_grecstoken;
  if (yy_grecsn < 0 || YYLAST < yy_grecsn || yy_grecscheck[yy_grecsn] != yy_grecstoken)
    goto yy_grecsdefault;
  yy_grecsn = yy_grecstable[yy_grecsn];
  if (yy_grecsn <= 0)
    {
      if (yy_grecsn == 0 || yy_grecsn == YYTABLE_NINF)
	goto yy_grecserrlab;
      yy_grecsn = -yy_grecsn;
      goto yy_grecsreduce;
    }

  if (yy_grecsn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yy_grecserrstatus)
    yy_grecserrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yy_grecstoken, &yy_grecslval, &yy_grecslloc);

  /* Discard the shifted token unless it is eof.  */
  if (yy_grecschar != YYEOF)
    yy_grecschar = YYEMPTY;

  yy_grecsstate = yy_grecsn;
  *++yy_grecsvsp = yy_grecslval;

  goto yy_grecsnewstate;


/*-----------------------------------------------------------.
| yy_grecsdefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yy_grecsdefault:
  yy_grecsn = yy_grecsdefact[yy_grecsstate];
  if (yy_grecsn == 0)
    goto yy_grecserrlab;
  goto yy_grecsreduce;


/*-----------------------------.
| yy_grecsreduce -- Do a reduction.  |
`-----------------------------*/
yy_grecsreduce:
  /* yy_grecsn is the number of a rule to reduce with.  */
  yy_grecslen = yy_grecsr2[yy_grecsn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yy_grecsval = yy_grecsvsp[1-yy_grecslen];


  YY_REDUCE_PRINT (yy_grecsn);
  switch (yy_grecsn)
    {
        case 7:
#line 96 "grecs-gram.y"
    {
	    process_ident((yy_grecsvsp[(1) - (3)].kw), &(yy_grecsvsp[(2) - (3)].value));
	  }
    break;

  case 8:
#line 101 "grecs-gram.y"
    { stmt_begin((yy_grecsvsp[(1) - (2)].kw), (yy_grecsvsp[(2) - (2)].value)); }
    break;

  case 9:
#line 102 "grecs-gram.y"
    {
	    stmt_end((yy_grecsvsp[(1) - (7)].kw));
	  }
    break;

  case 10:
#line 108 "grecs-gram.y"
    {
	    (yy_grecsval.kw) = find_keyword((yy_grecsvsp[(1) - (1)].string));
	    if (!(yy_grecsval.kw)) 
	      grecs_error(&grecs_current_locus, 0, _("Unknown keyword"));
	  }
    break;

  case 11:
#line 116 "grecs-gram.y"
    {
	    (yy_grecsval.value).type = GRECS_TYPE_STRING;
	    (yy_grecsval.value).v.string = NULL;
	  }
    break;

  case 13:
#line 124 "grecs-gram.y"
    {
	    size_t n;
	    
	    if ((n = gl_list_size ((yy_grecsvsp[(1) - (1)].list))) == 1)
	      {
		(yy_grecsval.value) = *(grecs_value_t *)gl_list_get_at ((yy_grecsvsp[(1) - (1)].list), 0);
	      }
	    else
	      {
		size_t i;
		
		(yy_grecsval.value).type = GRECS_TYPE_ARRAY;
		(yy_grecsval.value).v.arg.c = n;
		(yy_grecsval.value).v.arg.v = xcalloc (n, sizeof ((yy_grecsval.value).v.arg.v[0]));
		for (i = 0; i < n; i++)
		  (yy_grecsval.value).v.arg.v[i] = *(grecs_value_t *)gl_list_get_at ((yy_grecsvsp[(1) - (1)].list), i);
	      }
	    gl_list_free ((yy_grecsvsp[(1) - (1)].list));	      
	  }
    break;

  case 14:
#line 146 "grecs-gram.y"
    {
	    (yy_grecsval.list) = simple_list_create (false);
	    gl_list_add_last ((yy_grecsval.list), grecs_value_dup (&(yy_grecsvsp[(1) - (1)].value)));
	  }
    break;

  case 15:
#line 151 "grecs-gram.y"
    {
	    gl_list_add_last ((yy_grecsvsp[(1) - (2)].list), grecs_value_dup (&(yy_grecsvsp[(2) - (2)].value)));
	  }
    break;

  case 16:
#line 157 "grecs-gram.y"
    {
	    (yy_grecsval.value).type = GRECS_TYPE_STRING;
	    (yy_grecsval.value).v.string = (yy_grecsvsp[(1) - (1)].string);
	  }
    break;

  case 17:
#line 162 "grecs-gram.y"
    {
	    (yy_grecsval.value).type = GRECS_TYPE_LIST;
	    (yy_grecsval.value).v.list = (yy_grecsvsp[(1) - (1)].list);
	  }
    break;

  case 18:
#line 167 "grecs-gram.y"
    {
	    (yy_grecsval.value).type = GRECS_TYPE_STRING;
	    (yy_grecsval.value).v.string = (yy_grecsvsp[(1) - (1)].string);
	  }
    break;

  case 22:
#line 179 "grecs-gram.y"
    {
	    const void *p;
	    gl_list_iterator_t itr = gl_list_iterator ((yy_grecsvsp[(1) - (1)].list));

	    grecs_line_begin ();
	    while (gl_list_iterator_next (&itr, &p, NULL))
	      grecs_line_add (p, strlen (p));
	    (yy_grecsval.string) = grecs_line_finish ();
	    gl_list_iterator_free (&itr);
	    gl_list_free ((yy_grecsvsp[(1) - (1)].list));
	  }
    break;

  case 23:
#line 193 "grecs-gram.y"
    {
	    (yy_grecsval.list) = simple_list_create (false);
	    gl_list_add_last ((yy_grecsval.list), (yy_grecsvsp[(1) - (1)].string));
	  }
    break;

  case 24:
#line 198 "grecs-gram.y"
    {
	    gl_list_add_last ((yy_grecsvsp[(1) - (2)].list), (yy_grecsvsp[(2) - (2)].string));
	    (yy_grecsval.list) = (yy_grecsvsp[(1) - (2)].list);
	  }
    break;

  case 25:
#line 205 "grecs-gram.y"
    {
	    (yy_grecsval.list) = NULL;
	  }
    break;

  case 26:
#line 209 "grecs-gram.y"
    {
	    (yy_grecsval.list) = (yy_grecsvsp[(2) - (3)].list);
	  }
    break;

  case 27:
#line 213 "grecs-gram.y"
    {
	    (yy_grecsval.list) = (yy_grecsvsp[(2) - (4)].list);
	  }
    break;

  case 28:
#line 219 "grecs-gram.y"
    {
	    (yy_grecsval.list) = simple_list_create (false);
	    gl_list_add_last ((yy_grecsval.list), grecs_value_dup (&(yy_grecsvsp[(1) - (1)].value)));
	  }
    break;

  case 29:
#line 224 "grecs-gram.y"
    {
	    gl_list_add_last ((yy_grecsvsp[(1) - (3)].list), grecs_value_dup (&(yy_grecsvsp[(3) - (3)].value)));
	    (yy_grecsval.list) = (yy_grecsvsp[(1) - (3)].list);
	  }
    break;


/* Line 1267 of yacc.c.  */
#line 1580 "grecs-gram.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yy_grecsr1[yy_grecsn], &yy_grecsval, &yy_grecsloc);

  YYPOPSTACK (yy_grecslen);
  yy_grecslen = 0;
  YY_STACK_PRINT (yy_grecsss, yy_grecsssp);

  *++yy_grecsvsp = yy_grecsval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yy_grecsn = yy_grecsr1[yy_grecsn];

  yy_grecsstate = yy_grecspgoto[yy_grecsn - YYNTOKENS] + *yy_grecsssp;
  if (0 <= yy_grecsstate && yy_grecsstate <= YYLAST && yy_grecscheck[yy_grecsstate] == *yy_grecsssp)
    yy_grecsstate = yy_grecstable[yy_grecsstate];
  else
    yy_grecsstate = yy_grecsdefgoto[yy_grecsn - YYNTOKENS];

  goto yy_grecsnewstate;


/*------------------------------------.
| yy_grecserrlab -- here on detecting error |
`------------------------------------*/
yy_grecserrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yy_grecserrstatus)
    {
      ++yy_grecsnerrs;
#if ! YYERROR_VERBOSE
      yy_grecserror (YY_("syntax error"));
#else
      {
	YYSIZE_T yy_grecssize = yy_grecssyntax_error (0, yy_grecsstate, yy_grecschar);
	if (yy_grecsmsg_alloc < yy_grecssize && yy_grecsmsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yy_grecsalloc = 2 * yy_grecssize;
	    if (! (yy_grecssize <= yy_grecsalloc && yy_grecsalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yy_grecsalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yy_grecsmsg != yy_grecsmsgbuf)
	      YYSTACK_FREE (yy_grecsmsg);
	    yy_grecsmsg = (char *) YYSTACK_ALLOC (yy_grecsalloc);
	    if (yy_grecsmsg)
	      yy_grecsmsg_alloc = yy_grecsalloc;
	    else
	      {
		yy_grecsmsg = yy_grecsmsgbuf;
		yy_grecsmsg_alloc = sizeof yy_grecsmsgbuf;
	      }
	  }

	if (0 < yy_grecssize && yy_grecssize <= yy_grecsmsg_alloc)
	  {
	    (void) yy_grecssyntax_error (yy_grecsmsg, yy_grecsstate, yy_grecschar);
	    yy_grecserror (yy_grecsmsg);
	  }
	else
	  {
	    yy_grecserror (YY_("syntax error"));
	    if (yy_grecssize != 0)
	      goto yy_grecsexhaustedlab;
	  }
      }
#endif
    }



  if (yy_grecserrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yy_grecschar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yy_grecschar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yy_grecsdestruct ("Error: discarding",
		      yy_grecstoken, &yy_grecslval);
	  yy_grecschar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yy_grecserrlab1;


/*---------------------------------------------------.
| yy_grecserrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yy_grecserrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yy_grecserrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yy_grecserrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yy_grecslen);
  yy_grecslen = 0;
  YY_STACK_PRINT (yy_grecsss, yy_grecsssp);
  yy_grecsstate = *yy_grecsssp;
  goto yy_grecserrlab1;


/*-------------------------------------------------------------.
| yy_grecserrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yy_grecserrlab1:
  yy_grecserrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yy_grecsn = yy_grecspact[yy_grecsstate];
      if (yy_grecsn != YYPACT_NINF)
	{
	  yy_grecsn += YYTERROR;
	  if (0 <= yy_grecsn && yy_grecsn <= YYLAST && yy_grecscheck[yy_grecsn] == YYTERROR)
	    {
	      yy_grecsn = yy_grecstable[yy_grecsn];
	      if (0 < yy_grecsn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yy_grecsssp == yy_grecsss)
	YYABORT;


      yy_grecsdestruct ("Error: popping",
		  yy_grecsstos[yy_grecsstate], yy_grecsvsp);
      YYPOPSTACK (1);
      yy_grecsstate = *yy_grecsssp;
      YY_STACK_PRINT (yy_grecsss, yy_grecsssp);
    }

  if (yy_grecsn == YYFINAL)
    YYACCEPT;

  *++yy_grecsvsp = yy_grecslval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yy_grecsstos[yy_grecsn], yy_grecsvsp, yy_grecslsp);

  yy_grecsstate = yy_grecsn;
  goto yy_grecsnewstate;


/*-------------------------------------.
| yy_grecsacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yy_grecsacceptlab:
  yy_grecsresult = 0;
  goto yy_grecsreturn;

/*-----------------------------------.
| yy_grecsabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yy_grecsabortlab:
  yy_grecsresult = 1;
  goto yy_grecsreturn;

#ifndef yy_grecsoverflow
/*-------------------------------------------------.
| yy_grecsexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yy_grecsexhaustedlab:
  yy_grecserror (YY_("memory exhausted"));
  yy_grecsresult = 2;
  /* Fall through.  */
#endif

yy_grecsreturn:
  if (yy_grecschar != YYEOF && yy_grecschar != YYEMPTY)
     yy_grecsdestruct ("Cleanup: discarding lookahead",
		 yy_grecstoken, &yy_grecslval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yy_grecslen);
  YY_STACK_PRINT (yy_grecsss, yy_grecsssp);
  while (yy_grecsssp != yy_grecsss)
    {
      yy_grecsdestruct ("Cleanup: popping",
		  yy_grecsstos[*yy_grecsssp], yy_grecsvsp);
      YYPOPSTACK (1);
    }
#ifndef yy_grecsoverflow
  if (yy_grecsss != yy_grecsssa)
    YYSTACK_FREE (yy_grecsss);
#endif
#if YYERROR_VERBOSE
  if (yy_grecsmsg != yy_grecsmsgbuf)
    YYSTACK_FREE (yy_grecsmsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yy_grecsresult);
}


#line 234 "grecs-gram.y"


int
yy_grecserror(char *s)
{
  grecs_error (&grecs_current_locus, 0, "%s", s);
  return 0;
}

static void
listel_dispose(const void *el)
{
  free((void*)el);
}
 
static gl_list_t
simple_list_create (bool dispose)
{
  return gl_list_create_empty(&gl_linked_list_implementation,
			      NULL,
			      NULL,
			      dispose ? listel_dispose : NULL,
			      false);
}

 
void
grecs_warning(grecs_locus_t *locus, int errcode, const char *fmt, ...)
{
  va_list ap;
  char *buf = NULL;
  
  va_start (ap, fmt);
  vasprintf (&buf, fmt, ap);
  va_end (ap);
  grecs_print_diag (locus, 0, errcode, buf);
  free(buf);
}    

void
grecs_error (grecs_locus_t *locus, int errcode, const char *fmt, ...)
{
  va_list ap;
  char *buf = NULL;
  
  va_start (ap, fmt);
  vasprintf (&buf, fmt, ap);
  va_end (ap);
  grecs_print_diag (locus, 1, errcode, buf);
  free (buf);
  grecs_error_count++;
}

void
grecs_set_keywords (struct grecs_keyword *kwd)
{
  config_keywords.kwd = kwd;
}

int
grecs_parse (const char *name)
{
  int rc;
  if (grecs_lex_begin (name))
    return 1;
  cursect = &config_keywords;
  if (sections)
    {
      gl_list_free (sections);
      sections = NULL;
    }
  rc = yy_grecsparse ();
  grecs_lex_end ();
  if (grecs_error_count)
    rc = 1;
  return rc;
}

void
grecs_gram_trace (int n)
{
  yy_grecsdebug = n;
}



static void *
target_ptr (struct grecs_keyword *kwp, char *base)
{
  if (kwp->varptr)
    base = (char*) kwp->varptr + kwp->offset;
  else if (base)
    base += kwp->offset;
  
  return base;
}
    
static int
fake_callback (enum grecs_callback_command cmd,
	       grecs_locus_t *locus,
	       void *varptr,
	       grecs_value_t *value,
	       void *cb_data)
{
  return 0;
}

static struct grecs_keyword fake = {
  "*",
  NULL,
  NULL,
  grecs_type_void,
  NULL,
  0,
  fake_callback,
  NULL,
  &fake
};

static void
stmt_begin (struct grecs_keyword *kwp, grecs_value_t tag)
{
  void *target;
  
  if (!sections)
    sections = simple_list_create (false);
  gl_list_add_first (sections, cursect);
  if (kwp)
    {
      target = target_ptr (kwp, CURRENT_BASE);
      cursect = kwp;
      if (kwp->callback && kwp->callback (grecs_callback_section_begin,
					  &grecs_current_locus, /* FIXME */
					  target,
					  &tag,
					  &kwp->callback_data))
	cursect = &fake;
    }
  else
    /* install "ignore-all" section */
    cursect = kwp;
}

static void
stmt_end (struct grecs_keyword *kwp)
{
  grecs_callback_fn callback = NULL;
  void *dataptr = NULL;
  
  if (cursect && cursect->callback)
    {
      callback = cursect->callback;
      dataptr = &cursect->callback_data;
    }

  if (gl_list_size (sections) == 0)
    abort ();
  cursect = (struct grecs_keyword *) gl_list_get_at (sections, 0);
  gl_list_remove_at (sections, 0);
  if (callback)
    callback (grecs_callback_section_end,
	      &grecs_current_locus, /* FIXME */
	      kwp ? target_ptr (kwp, CURRENT_BASE) : NULL,
	      NULL,
	      dataptr);

}

static struct grecs_keyword *
find_keyword (const char *ident)
{
  struct grecs_keyword *kwp;
  
  if (cursect && cursect != &fake)
    {
      for (kwp = cursect->kwd; kwp->ident; kwp++)
	if (strcmp (kwp->ident, ident) == 0)
	  return kwp;
    }
  else
    {
      return &fake;
    }
  return NULL;
}

static int
string_to_signed (intmax_t *sval, const char *string,
		  intmax_t minval, intmax_t maxval, grecs_locus_t *locus)
{
  intmax_t t;
  char *p;
  
  t = strtoimax (string, &p, 0);
  if (*p)
    {
      grecs_error (locus, 0, _("cannot convert `%s' to number"),
		   string);
      return 1;
    }
  else if (t < minval || t > maxval)
    {
      grecs_error (locus, 0,
		   _("%s: value out of allowed range %"PRIiMAX"..%"PRIiMAX),
		   string, minval, maxval);
      return 1;
    }
  *sval = t;
  return 0;
}
    
static int
string_to_unsigned (uintmax_t *sval, const char *string, uintmax_t maxval,
		    grecs_locus_t *locus)
{
  uintmax_t t;
  char *p;
    
  t = strtoumax (string, &p, 0);
  if (*p)
    {
      grecs_error (locus, 0, _("cannot convert `%s' to number"),
		   string);
      return 1;
    }
  else if (t > maxval)
    {
      grecs_error (locus, 0,
		   _("%s: value out of allowed range 0..%"PRIuMAX),
		   string, maxval);
      return 1;
    }
  *sval = t;
  return 0;
}

static int
string_to_bool (const char *string, int *pval, grecs_locus_t *locus)
{
  if (strcmp (string, "yes") == 0
      || strcmp (string, "true") == 0
      || strcmp (string, "t") == 0
      || strcmp (string, "1") == 0)
    *pval = 1;
  else if (strcmp (string, "no") == 0
	   || strcmp (string, "false") == 0
	   || strcmp (string, "nil") == 0
	   || strcmp (string, "0") == 0)
    *pval = 0;
  else
    {
      grecs_error (locus, 0, _("%s: not a valid boolean value"), string);
      return 1;
    }
  return 0;
}

static int
string_to_host (struct in_addr *in, const char *string, grecs_locus_t *locus)
{
  if (inet_aton (string, in) == 0)
    {
      struct hostent *hp;

      hp = gethostbyname (string);
      if (hp == NULL)
	return 1;
      memcpy (in, hp->h_addr, sizeof (struct in_addr));
    }
  return 0;
}

static int
string_to_sockaddr (struct grecs_sockaddr *sp, const char *string,
		    grecs_locus_t *locus)
{
  if (string[0] == '/')
    {
      struct sockaddr_un s_un;
      if (strlen (string) >= sizeof (s_un.sun_path))
	{
	  grecs_error (locus, 0, _("%s: UNIX socket name too long"), string);
	  return 1;
	}
      s_un.sun_family = AF_UNIX;
      strcpy (s_un.sun_path, string);
      sp->len = sizeof (s_un);
      sp->sa = xmalloc (sp->len);
      memcpy (sp->sa, &s_un, sp->len);
    }
  else
    {
      char *p = strchr (string, ':');
      size_t len;
      struct sockaddr_in sa;

      sa.sin_family = AF_INET;
      if (p) 
	len = p - string;
      else
	len = strlen (string);
      
      if (len == 0)
	sa.sin_addr.s_addr = INADDR_ANY;
      else
	{
	  char *host = xmalloc (len + 1);
	  memcpy (host, string, len);
	  host[len] = 0;
	  
	  if (string_to_host (&sa.sin_addr, host, locus))
	    {
	      grecs_error (locus, 0,
			   _("%s: not a valid IP address or hostname"),
			   host);
	      free (host);
	      return 1;
	    }
	  free (host);
	}
	
      if (p)
	{
	  struct servent *serv;

	  p++;
	  serv = getservbyname (p, "tcp");
	  if (serv != NULL)
	    sa.sin_port = serv->s_port;
	  else
	    {
	      unsigned long l;
	      char *q;
	      
	      /* Not in services, maybe a number? */
	      l = strtoul (p, &q, 0);
	      
	      if (*q || l > USHRT_MAX)
		{
		  grecs_error (locus, 0,
			       _("%s: not a valid port number"), p);
		  return 1;
		}
	      sa.sin_port = htons (l);
	    }
	}
      else if (grecs_default_port)
	sa.sin_port = grecs_default_port;
      else
	{
	  grecs_error (locus, 0, _("missing port number"));
	  return 1;
	}
      sp->len = sizeof (sa);
      sp->sa = xmalloc (sp->len);
      memcpy (sp->sa, &sa, sp->len);
    }
  return 0;
}

int
grecs_string_convert (void *target, enum grecs_data_type type,
		      const char *string, grecs_locus_t *locus)
{
  uintmax_t uval;
  intmax_t sval;
	
  switch (type)
    {
    case grecs_type_void:
      abort ();
	    
    case grecs_type_string:
      *(const char**)target = string;
      break;
	    
    case grecs_type_short:
      if (string_to_signed (&sval, string, SHRT_MIN, SHRT_MAX, locus) == 0)
	*(short*)target = sval;
      else
	return 1;
      break;
	    
    case grecs_type_ushort:
      if (string_to_unsigned (&uval, string, USHRT_MAX, locus) == 0)
	*(unsigned short*)target = uval;
      else
	return 1;
      break;
	    
    case grecs_type_bool:
      return string_to_bool (string, (int*)target, locus);
	    
    case grecs_type_int:
      if (string_to_signed (&sval, string, INT_MIN, INT_MAX, locus) == 0)
	*(int*)target = sval;
      else
	return 1;
      break;
	    
    case grecs_type_uint:
      if (string_to_unsigned (&uval, string, UINT_MAX, locus) == 0)
	*(unsigned int*)target = uval;
      else
	return 1;
      break;
	    
    case grecs_type_long:
      if (string_to_signed (&sval, string, LONG_MIN, LONG_MAX, locus) == 0)
	*(long*)target = sval;
      else
	return 1;
      break;
	    
    case grecs_type_ulong:
      if (string_to_unsigned (&uval, string, ULONG_MAX, locus) == 0)
	*(unsigned long*)target = uval;
      else
	return 1;
      break;
	    
    case grecs_type_size:
      if (string_to_unsigned (&uval, string, SIZE_MAX, locus) == 0)
	*(size_t*)target = uval;
      else
	return 1;
      break;
	    
    case grecs_type_intmax:
      return string_to_signed ((intmax_t*)target, string,
			       INTMAX_MIN, INTMAX_MAX, locus);
	    
    case grecs_type_uintmax:
      return string_to_unsigned ((uintmax_t*)target, string, UINTMAX_MAX,
				 locus);
	    
    case grecs_type_time:
      /*FIXME: Use getdate */
      if (string_to_unsigned (&uval, string, (time_t)-1, locus) == 0)
	*(time_t*)target = uval;
      else
	return 1;
      break;

    case grecs_type_ipv4:
      if (inet_aton (string, (struct in_addr *)target))
	{
	  grecs_error (locus, 0, _("%s: not a valid IP address"), string);
	  return 1;
	}
      break;
	
    case grecs_type_host:
      if (string_to_host ((struct in_addr *)target, string, locus))
	{
	  grecs_error (locus, 0,
		       _("%s: not a valid IP address or hostname"), string);
	  return 1;
	}
      break;    
	    
    case grecs_type_sockaddr:
      return string_to_sockaddr ((struct grecs_sockaddr *)target, string,
				 locus);
      
      /* FIXME: */
    case grecs_type_cidr:
      grecs_error (locus, 0, _("INTERNAL ERROR at %s:%d"), __FILE__, __LINE__);
      abort();
	    
    case grecs_type_section:
      grecs_error (locus, 0,
		   _("invalid use of block statement"));
      return 1;
    }
  return 0;
}

struct grecs_prop
{
  size_t size;
  gl_listelement_equals_fn eqfn;
};

static bool
string_eq (const void *elt1, const void *elt2)
{
  return strcmp ((const char *)elt1, (const char *)elt2) == 0;
}

#define __grecs_name_cat__(a,b) a ## b
#define NUMEQ(type) __grecs_name_cat__(type,_eq)
#define __DECL_NUMEQ(type,ctype)			\
  static bool						\
  NUMEQ(type) (const void *elt1, const void *elt2)	\
  {							\
    return memcmp (elt1, elt2, sizeof (ctype)) == 0;	\
  }
#define DECL_NUMEQ(type) __DECL_NUMEQ(type,type)

DECL_NUMEQ(short)
DECL_NUMEQ(int)
DECL_NUMEQ(long)
DECL_NUMEQ(size_t)
DECL_NUMEQ(uintmax_t)
DECL_NUMEQ(intmax_t)
DECL_NUMEQ(time_t)
__DECL_NUMEQ(in_addr, struct in_addr)
__DECL_NUMEQ(grecs_sockaddr, struct grecs_sockaddr)

struct grecs_prop grecs_prop_tab[] = {
  { 0, NULL },                                  /* grecs_type_void */
  { sizeof (char*), string_eq },                /* grecs_type_string */
  { sizeof (short), NUMEQ (short) },            /* grecs_type_short */
  { sizeof (unsigned short), NUMEQ (short) },   /* grecs_type_ushort */
  { sizeof (int), NUMEQ (int) },                /* grecs_type_int */
  { sizeof (unsigned int), NUMEQ (int) },       /* grecs_type_uint */
  { sizeof (long), NUMEQ (long) },              /* grecs_type_long */
  { sizeof (unsigned long), NUMEQ (long) },     /* grecs_type_ulong */
  { sizeof (size_t), NUMEQ (size_t) },          /* grecs_type_size */
  /*    grecs_type_off,*/
  { sizeof (uintmax_t), NUMEQ (uintmax_t) },    /* grecs_type_uintmax */
  { sizeof (intmax_t), NUMEQ (intmax_t) },      /* grecs_type_intmax */
  { sizeof (time_t), NUMEQ (time_t) },          /* grecs_type_time */
  { sizeof (int), NUMEQ (int) },                /* grecs_type_bool */
  { sizeof (struct in_addr), NUMEQ (in_addr) }, /* grecs_type_ipv4 */
  { 0, NULL },                           /* FIXME: grecs_type_cidr */
  { sizeof (struct in_addr), NUMEQ (in_addr) }, /* grecs_type_host */ 
  { sizeof (struct grecs_sockaddr), NUMEQ (grecs_sockaddr) },
                                                /* grecs_type_sockaddr */
  { 0, NULL }                                   /* grecs_type_section */
};
#define grecs_prop_count \
  (sizeof (grecs_prop_tab) / sizeof (grecs_prop_tab[0]))

void
grecs_process_ident (struct grecs_keyword *kwp, grecs_value_t *value,
		     void *base, grecs_locus_t *locus)
{
  void *target;

  if (!kwp)
    return;
  
  target = target_ptr (kwp, (char *) base);
  
  if (kwp->callback)
    kwp->callback (grecs_callback_set_value,
		   locus,
		   target,
		   value,
		   &kwp->callback_data);
  else if (value->type == GRECS_TYPE_ARRAY)
    {
      grecs_error (locus, 0,
		   _("too many arguments to `%s'; missing semicolon?"),
		   kwp->ident);
      return;
    }
  else if (value->type == GRECS_TYPE_LIST)
    {
      if (GRECS_IS_LIST (kwp->type))
	{
	  gl_list_iterator_t itr = gl_list_iterator (value->v.list);
	  enum grecs_data_type type = GRECS_TYPE (kwp->type);
	  int num = 1;
	  const void *p;
	  gl_list_t list;
	  size_t size;

	  if (type >= grecs_prop_count
	      || (size = grecs_prop_tab[type].size) == 0)
	    {
	      grecs_error (locus, 0,
			   _("INTERNAL ERROR at %s:%d: "
			     "unhandled data type %d"),
			   __FILE__, __LINE__, type);
	      abort ();
	    }

	  list = gl_list_create_empty (&gl_linked_list_implementation,
				       grecs_prop_tab[type].eqfn,
				       NULL,
				       NULL,
				       false);
	  
	  while (gl_list_iterator_next (&itr, &p, NULL))
	    {
	      const grecs_value_t *vp = p;

	      if (vp->type != GRECS_TYPE_STRING)
		grecs_error (locus, 0,
			     _("%s: incompatible data type in list item #%d"),
			     kwp->ident, num);
	      else if (type == grecs_type_string)
		gl_list_add_last (list, vp->v.string);
	      else
		{
		  void *ptr = xmalloc (size);
		  if (grecs_string_convert (ptr, type, vp->v.string,
					    locus) == 0) 
		    gl_list_add_last (list, ptr);
		  else
		    free (ptr);
		}
	    }
	  gl_list_iterator_free (&itr);
	  *(gl_list_t*)target = list;
	}
      else
	{
	  grecs_error (locus, 0,
		       _("incompatible data type for `%s'"),
		       kwp->ident);
	  return;
	}
    }
  else if (GRECS_IS_LIST (kwp->type))
    {
      gl_list_t list;
      enum grecs_data_type type = GRECS_TYPE (kwp->type);
      size_t size;
      void *ptr;
      
      if (type >= grecs_prop_count
	  || (size = grecs_prop_tab[type].size) == 0)
	{
	  grecs_error (locus, 0,
		       _("INTERNAL ERROR at %s:%d: unhandled data type %d"),
		       __FILE__, __LINE__, type);
	  abort();
	}
      
      list = gl_list_create_empty (&gl_linked_list_implementation,
				   grecs_prop_tab[type].eqfn,
				   NULL,
				   listel_dispose,
				   false);
      if (type == grecs_type_string)
	gl_list_add_last (list, value->v.string);
      else
	{
	  ptr = xmalloc (size);
	  if (grecs_string_convert (ptr, type, value->v.string, locus))
	    {
	      free (ptr);
	      gl_list_free (list);
	      return;
	    }
	  gl_list_add_last (list, ptr);
	}
      *(gl_list_t*)target = list;
    }
  else
    grecs_string_convert (target, GRECS_TYPE (kwp->type), value->v.string,
			  locus);
}

static void
process_ident (struct grecs_keyword *kwp, grecs_value_t *value)
{
  grecs_process_ident (kwp, value, CURRENT_BASE, &grecs_current_locus);
}
    


